/*
 * This file is part of the LIBCGI library
 *
 * Copyright 1994 by Enterprise Integration Technologies Corporation
 *
 * This is freeware with commercialization rights reserved; see the
 * LICENSE included in the distribution for specifics.
 */

#ifndef CGI_H
#define CGI_H

#include <sys/cdefs.h>

#define MCODE_GET 1
#define MCODE_POST 2
#define MCODE_PUT 3
#define MCODE_HEAD 4

typedef struct
{
  char *server_software;
  char *server_name;
  char *gateway_interface;
  char *server_protocol;
  char *server_port;
  char *request_method;
  char *http_accept;
  char *path_info;
  char *path_translated;
  char *script_name;
  char *query_string;
  char *remote_host;
  char *remote_addr;
  char *auth_type;
  char *remote_user;
  char *remote_ident;
  char *content_type;
  int content_length;
} cgi_info;

typedef struct festruct
{
  char *name;
  char *val;
  struct festruct *next;
} form_entry;

/* Prototypes */
/* ---------- */
char *parmval __P((form_entry *, char *));
form_entry *get_form_entries __P((cgi_info *));
void print_input_blank __P((char *, unsigned, unsigned, char *));
void print_sel_list __P((char *, char **, char *));
void print_submit __P((char *));
void print_doc_begin __P((char *));
char *trim __P((char *));
char *sanitize __P((char *, char *));
char *strmaxcpy __P((char *, char *, int));
int get_cgi_info __P((cgi_info *ci));
int syn_mimeheader __P((char *, char *));
int print_mimeheader __P((char *));
int syn_base_url __P((char *, cgi_info *));
int print_base_url __P((cgi_info *));
int mcode __P((cgi_info *));

#endif
